#include<bits/stdc++.h>
using namespace std;
int br[1000001];
vector<pair<int, int>> v[1000001];
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m=0;
    cin>>n;
    for(int i=0;i<n;i++){
        int a, b;
        cin>>a>>b;
        m=max(m, b);
        for(int j=a;j<b;j++){
            br[j]++;
            v[j].push_back({a, b});
        }
    }
    int ans=0, index;
    for(int i=0;i<m;i++){
        if(br[i]>ans){
            index=i;
            ans=br[i];
        }
    }
    cout<<ans<<endl;
    int min_=m+1, max_=0;
    for(int i=0;i<v[index].size();i++){
        min_=min(min_, v[index][i].first);
        max_=max(max_, v[index][i].second);
    }
    cout<<max_-min_;
    return 0;
}
